/* a little utility to generate config.h from config.h.h */

#include <stdio.h>
#include <string.h>

#define N 32768

/* NEVER EVER use static sized buffer with scanf.
 * So why do we do it here? Well... it should not crash, or?
 * I mean 32768 is much enough for a URL, a file name, a hostname, no?
 * And this program is to be used locally when generating client.
 * If you ever use it with automatic tools, change. There is
 * a very high risk of security breaching here.
 */
char server[N];
char port[N];
char url[N];
char keyfile[N];
char ivfile[N];

char token[2048];

int main(int n, char **v)
{
  FILE *in = fopen(v[1], "rb");
  FILE *out = fopen(v[2], "wb");
  int i;
  printf("server (example: sed.free.fr): ");
  scanf("%s", server);
  printf("port (example: 80): ");
  scanf("%s", port);
  printf("url (example: /phpoor/phpoor.php): ");
  scanf("%s", url);
  printf("key file (example: key): ");
  scanf("%s", keyfile);
  printf("iv file (example: iv): ");
  scanf("%s", ivfile);

  while (!feof(in)) {
    int c = fgetc(in);
    if (c == -1) break;
    if (c != '$') { fprintf(out, "%c", c); continue; }
    i = 0;
    do {
      c = fgetc(in);
      if (c == -1) break;
      token[i] = c;
      i++;
      if (i == 2047) {
        fprintf(stderr, "bad token\n");
        return 1;
      }
    } while (c != '$');
    token[i-1] = 0;
    if (!strcmp(token, "SERVER")) fprintf(out, "\"%s\"", server);
    else if (!strcmp(token, "PORT")) fprintf(out, "%s", port);
    else if (!strcmp(token, "URL")) fprintf(out, "\"%s\"", url);
    else if (!strcmp(token, "KEY_FILE")) fprintf(out, "\"%s\"", keyfile);
    else if (!strcmp(token, "IV_FILE")) fprintf(out, "\"%s\"", ivfile);
    else fprintf(stderr, "unknown token: %s\n", token);
  }

  fclose(in);
  fclose(out);

  return 0;
}
