/* generated by gtkcooker (http://www.nongnu.org/gtkcooker) */

#ifndef _GUI_H_
#define _GUI_H_

#include <gtk/gtk.h>
#include <stdio.h>
#include "list.h"



/* the fixed size of the log window */
#define LOG_WIDTH	80
#define LOG_HEIGHT	500

struct main_gui;

void log_append(struct main_gui *, char *);
void refresh_remote_files(struct main_gui *);
void refresh_local_files(struct main_gui *);


typedef struct continue_widget {
 struct main_gui *m; void (*fun)(struct main_gui *, int); 
  GtkWidget *win;
  unsigned long win_delete;
  unsigned long over_clicked;
  unsigned long resume_clicked;
  unsigned long _cancel_clicked;
} continue_widget;

typedef struct verify_widget {
 struct main_gui *m; 
  GtkWidget *win;
  unsigned long win_delete;
  unsigned long over_clicked;
  unsigned long verify_clicked;
  unsigned long _cancel_clicked;
} verify_widget;

typedef struct main_gui {

    char local_dir[FILENAME_MAX];
    char remote_dir[FILENAME_MAX];
    GdkFont *font;
    int font_height;
    int font_width;
    int font_ascent;
    list *local_files;
    list *remote_files;
    int line;
    int line_in_local;
    /* the buffer is organized as a list of strings with a 0 at the end,
     * thus the LOG_WIDTH+1
     */
    char log_data[(LOG_WIDTH+1) * LOG_HEIGHT];
    int log_line;
    int log_col;
    /* an ugly variable to scroll the log view at bottom at startup
     * this can only be done in the expose event, but we want to do it
     * only once, thus this variable
     */
    int first_log_expose;
    int old_local_line;
    int old_remote_line;
    /* another ugly variables to scroll the view when lists change */
    int local_size_changed;
    int remote_size_changed;
  
  GtkWidget *win;
  unsigned long win_delete;
  GtkWidget *local_dir_label;
  GtkWidget *remote_dir_label;
  unsigned long refresh_clicked;
  unsigned long bgoto_clicked;
  unsigned long bget_clicked;
  unsigned long bput_clicked;
  unsigned long bverify_clicked;
  unsigned long bmkdir_clicked;
  unsigned long bdel_clicked;
  unsigned long bmove_clicked;
  unsigned long rrefresh_clicked;
  unsigned long bquit_clicked;
  unsigned long bsync_clicked;
  GtkWidget *local_draw;
  unsigned long local_draw_expose;
  unsigned long local_draw_pointer_motion;
  unsigned long local_draw_pointer_press;
  unsigned long local_draw_pointer_release;
  GtkWidget *remote_draw;
  unsigned long remote_draw_expose;
  unsigned long remote_draw_pointer_motion;
  unsigned long remote_draw_pointer_press;
  unsigned long remote_draw_pointer_release;
  GtkWidget *log;
  unsigned long log_expose;
  unsigned long log_pointer_motion;
  unsigned long log_pointer_press;
  unsigned long log_pointer_release;
} main_gui;

typedef struct startup_widget {
 struct main_gui *m; int proxy_port; int backup_mode; 
  GtkWidget *win;
  unsigned long win_delete;
  GtkWidget *pass;
  unsigned long pass_activate;
  GtkWidget *server;
  GtkWidget *server_port;
  GtkWidget *server_url;
  GtkWidget *key_file;
  GtkWidget *iv_file;
  unsigned long bok_clicked;
  unsigned long bquit_clicked;
} startup_widget;

typedef struct goto_widget {
 struct main_gui *m; 
  GtkWidget *win;
  unsigned long win_delete;
  GtkWidget *goto_text;
  unsigned long goto_text_activate;
} goto_widget;

typedef struct mkdir_widget {
 struct main_gui *m; 
  GtkWidget *win;
  unsigned long win_delete;
  GtkWidget *mkdir_text;
  unsigned long mkdir_text_activate;
} mkdir_widget;

typedef struct confirm_del_gui {
 struct main_gui *m; 
  GtkWidget *win;
  unsigned long win_delete;
  unsigned long yes_clicked;
  unsigned long no_clicked;
} confirm_del_gui;

typedef struct move_gui {
 struct main_gui *m; 
  GtkWidget *win;
  unsigned long win_delete;
  GtkWidget *to_label;
  unsigned long yes_clicked;
  unsigned long no_clicked;
} move_gui;

int init_continue_widget(continue_widget *this, struct main_gui *m, void *windad, char *question,
                       char *_file, void (*fun)(struct main_gui *, int));
int init_verify_widget(verify_widget *this, struct main_gui *m, void *windad, char *question,
                     char *_file);
int init_main_gui(main_gui *this, list *local_files, list *remote_files);
int init_startup_widget(startup_widget *this, char *in_server, int in_port, char *in_url,
                      char *in_key_file, char *in_iv_file,
                      struct main_gui *m, int proxy_port,
                      int backup_mode);
int init_goto_widget(goto_widget *this, struct main_gui *m, void *dadwin);
int init_mkdir_widget(mkdir_widget *this, struct main_gui *m, void *windad);
int init_confirm_del_gui(confirm_del_gui *this, main_gui *m, void *dadwin);
int init_move_gui(move_gui *this, struct main_gui *m, void *dadwin);

#endif /* _GUI_H_ */
