#include "command.h"
#include "crypto.h"

#include "config.h"

#include "gui.h"
#include "list.h"
#include "proxy.h"
#include "backup.h"

#include <string.h>
#include <stdio.h>
#include <gtk/gtk.h>

#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>

/*#define TEST*/
#ifdef TEST
#include <stdarg.h>
extern buf from_server;
void lmess(const char *l, ...)
{
  va_list ap;
  va_start(ap, l);
  vprintf(l, ap);
  va_end(ap);
}

void lfmess(const char *b, int l)
{
  fwrite(b, l, 1, stdout);
}

void (*mess)(const char *, ...) = lmess;
void (*fmess)(const char *, int) = lfmess;
#else
extern void gui_mess(const char *, ...);
extern void gui_fmess(const char *, int);
void (*mess)(const char *, ...) = gui_mess;
void (*fmess)(const char *, int) = gui_fmess;
#endif

void reset_info(void)
{
  int i;
  printf("\r");
  for (i=0; i<60; i++) printf(" ");
  printf("\r");
}

void usage(void)
{
  printf("usage: client [options]\n");
  printf("options:\n");
  printf("  -p <port>: act as a proxy\n");
  printf("  -pd <file>: file to dump requests/replies to when proxy\n");
  printf("  -pr <file>: file to dump raw messages to when proxy\n");
  printf("  -backup <out dir>: do a local copy of the website\n");
  printf("  -depth <max depth>: limit depth in backup (default: infinite)\n");
  printf("  -dir <directory>: start backup in this directory (default: /)\n");
  printf("  -skipphpXXXXXX: skip files of name phpXXXXXX with X as anything\n");
  exit(0);
}

int main(int n, char **v)
{
#ifdef TEST
  int i;
  char pass[4096];

  printf("Pass phrase: ");
  for (i=0; i<4097; i++) {
    pass[i] = getchar();
    if (pass[i] == '\n') break;
  }
  if (i == 0 || pass[i] != '\n') {
    printf("bad pass phrase (we must have 0 < len <= 4096)\n");
    return 1;
  }
  if (read_key(KEY_FILE, pass, i) == -1) return 1;
  /* clear passphrase, just for paranoia (note that it may fail to
   * work if the host/os does some trickery with the memory)
   */
  for (; i>=0; i--) pass[i] = 0;

  { list lll; memset(&lll, 0, sizeof(list)); ls(&from_server, "/", &lll); }
  gt(&from_server, "test.input", "/index.html", 0, 44);
//  pt(&from_server, "zorba", "/zorba", 0, 4096);
//  md(&from_server, "test-dir");
//  dd(&from_server, "test-dir");
//  rn(&from_server, "/shell/server/pipo.txt", "/shell/client/popi.xtx");
//  printf("size=%d\n", fs(&from_server, "/shell/client/popi.xtx"));
  if (0) {
#include "sha1.h"
     extern void *malloc(int);
     char s[20];
     char ls[20];
     SHA1Context ctx;
     char *buf;
     int len;
     FILE *f;
     sh(&from_server, "/shell/client/popi.xtx", s);
     f = fopen("popi.xtx", "rb");
     len = 12;
     buf = malloc(len);
     fread(buf, len, 1, f);
     fclose(f);
     SHA1Reset(&ctx);
     SHA1Input(&ctx, buf, len);
     SHA1Result(&ctx, ls);
     for (i=0; i<20; i++) printf("%02X ", (unsigned char)s[i]); printf("\n");
     for (i=0; i<20; i++) printf("%02X ", (unsigned char)ls[i]); printf("\n");
  }

  ml(&from_server);

  clear_key();

  return 0;
#else
  main_gui m;
  startup_widget w;
  list local;
  list remote;
  struct timeval tim;
  int proxy_port = -1;
  int backup_mode = 0;
  int i;

  gettimeofday(&tim, 0);
  srand(tim.tv_sec + tim.tv_usec);

  memset(&local, 0, sizeof(list));
  memset(&remote, 0, sizeof(list));

  for (i = 1; i < n; i++) {
    if (!strcmp(v[i], "-p")) {
      if (i == n-1) usage();
      sscanf(v[i+1], "%d", &proxy_port);
      i++;
      continue;
    }
    if (!strcmp(v[i], "-pd")) {
      if (i == n-1) usage();
      proxy_dump_file = v[i+1];
      i++;
      continue;
    }
    if (!strcmp(v[i], "-pr")) {
      if (i == n-1) usage();
      proxy_dump_file_raw = v[i+1];
      i++;
      continue;
    }
    if (!strcmp(v[i], "-backup")) {
      if (i == n-1) usage();
      backup_dir = v[i+1];
      backup_mode = 1;
      i++;
      continue;
    }
    if (!strcmp(v[i], "-depth")) {
      if (i == n-1) usage();
      backup_depth = atoi(v[i+1]);
      i++;
      continue;
    }
    if (!strcmp(v[i], "-dir")) {
      if (i == n-1) usage();
      backup_single = v[i+1];
      i++;
      continue;
    }
    if (!strcmp(v[i], "-skipphpXXXXXX")) {
      skip_phpXXXXXX = 1;
      continue;
    }
    /* unknown option */
    usage();
  }

  if (proxy_port != -1) proxy_mess();
  if (backup_mode) backup_mess();

  gtk_init(0, 0);
  init_main_gui(&m, &local, &remote);
  init_startup_widget(&w, SERVER, PORT, URL, KEY_FILE, IV_FILE, &m,
                      proxy_port, backup_mode);
  gtk_widget_show_all(w.win);
  gtk_main();
  clear_key();
#endif
}
