#include "request.h"

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

static buf b[2];
buf *req = &b[0];
buf *body = &b[1];

void buf_reset(buf *b)
{
  b->size = 0;
}

void buf_ensure_size(buf *b, int size)
{
  if (b->maxsize >= size) return;
  b->buf = realloc(b->buf, size);
  if (!b->buf) { fprintf(stderr, "out of memory\n"); exit(1); }
  b->maxsize = size;
}

void buf_add_buffer(buf *b, char *s, int l)
{
  if (b->size + l > b->maxsize) {
    b->maxsize = b->size + l + 65536;
    b->buf = realloc(b->buf, b->maxsize);
    /* memory management: no memory => byebye. Normally it won't happen. */
    if (!b->buf) {
      fprintf(stderr, "out of memory\n");
      exit(1);
    }
  }

  memcpy(b->buf+b->size, s, l);
  b->size += l;
}

void buf_add_string(buf *b, char *s)
{
  buf_add_buffer(b, s, strlen(s));
}

void buf_add_eol(buf *b)
{
  char t[3];
  t[0] = 13;
  t[1] = 10;
  t[2] = 0;
  buf_add_string(b, t);
}

void buf_add_int(buf *b, int c)
{
  char t[64];
  sprintf(t, "%d", c);
  buf_add_string(b, t);
}

void buf_add_char(buf *b, int c)
{
  char t = c;
  buf_add_buffer(b, &t, 1);
}

char *buf_req(buf *b)
{
  return b->buf;
}

int buf_size(buf *b)
{
  return b->size;
}
