#ifndef _REQUEST_H_
#define _REQUEST_H_

typedef struct {
  char *buf;
  int size;
  int maxsize;
} buf;

void buf_reset(buf *);
void buf_add_string(buf *, char *);
void buf_add_char(buf *, int);
void buf_add_int(buf *, int);
void buf_add_eol(buf *);
void buf_add_buffer(buf *, char *, int);
void buf_ensure_size(buf *, int);
char *buf_req(buf *);
int buf_size(buf *);

#define r_reset() buf_reset(req)
#define r_add_string(s) buf_add_string(req, s)
#define r_add_char(i) buf_add_char(req, i)
#define r_add_int(i) buf_add_int(req, i)
#define r_add_eol() buf_add_eol(req)
#define r_add_buffer(a, b) buf_add_buffer(req, a, b)
#define r_req() buf_req(req)
#define r_size() buf_size(req)

#define b_reset() buf_reset(body)
#define b_add_string(s) buf_add_string(body, s)
#define b_add_char(i) buf_add_char(body, i)
#define b_add_int(i) buf_add_int(body, i)
#define b_add_eol() buf_add_eol(body)
#define b_add_buffer(a, b) buf_add_buffer(body, a, b)
#define b_req() buf_req(body)
#define b_size() buf_size(body)

#define c_reset() buf_reset(command)
#define c_add_string(s) buf_add_string(command, s)
#define c_add_char(i) buf_add_char(command, i)
#define c_add_int(i) buf_add_int(command, i)
#define c_add_eol() buf_add_eol(command)
#define c_add_buffer(a, b) buf_add_buffer(command, a, b)
#define c_req() buf_req(command)
#define c_size() buf_size(command)

extern buf *req;
extern buf *body;

#endif /* _REQUEST_H_ */
