#include <stdio.h>

#include "sha1.h"

int main(void)
{
  int i;
  unsigned char key[256/8];
  unsigned char sha1[32];
  SHA1Context ctx;
  char pass[4097];
  FILE *f = fopen("key.bin", "rb");
  if (!f) {
    printf("key.bin: no such file.\n");
    printf("Generate one please.\n");
    printf("Use the following command (or whatever you want):\n");
    printf("  dd if=/dev/urandom of=key.bin bs=32 count=1\n");
    printf("key.bin should be 32 bytes long.\n");
    return 1;
  }
  fread(key, 256/8, 1, f);
  fclose(f);

  printf("enter pass phrase: ");
  for (i=0; i<4097; i++) {
    pass[i] = getchar();
    if (pass[i] == '\n') break;
  }
  if (i == 0 || pass[i] != '\n') {
    printf("error with passphrase, too long? only 4096 bytes allowed\n");
    printf("(empty pass phrase is also not allowed)\n");
    return 1;
  }
  SHA1Reset(&ctx);
  SHA1Input(&ctx, (unsigned char *)pass, i);
  SHA1Result(&ctx, sha1);
  for (i = 20; i<32; i++)
    sha1[i] = sha1[i-20];

  f = fopen("key", "wb");
  for (i=0; i<256/8; i++)
    fprintf(f, "%02x", key[i] ^ sha1[i]);
  fclose(f);

  f = fopen("key.php", "wb");
  fprintf(f, "<?php $key = \"");
  for (i=0; i<256/8; i++)
    fprintf(f, "%02x", key[i]);
  fprintf(f, "\"; ?>\n");
  fclose(f);

  return 0;
}
