<?php

/* ripped from Bernstein's stuff as can be seen.
 * Public domain stuff
 * Hardcorely inefficient.
 * All data are strings.
 * May fail to work on some hosts, php is weird with integers.
 */
/*
salsa20-ref.c version 20051118
D. J. Bernstein
Public domain.
*/

function ROTATE($v,$c)
{
  $z = array (
    0xffffffff, 0x7fffffff, 0x3fffffff, 0x1fffffff,
    0x0fffffff, 0x07ffffff, 0x03ffffff, 0x01ffffff,
    0x00ffffff, 0x007fffff, 0x003fffff, 0x001fffff,
    0x000fffff, 0x0007ffff, 0x0003ffff, 0x0001ffff,
    0x0000ffff, 0x00007fff, 0x00003fff, 0x00001fff,
    0x00000fff, 0x000007ff, 0x000003ff, 0x000001ff,
    0x000000ff, 0x0000007f, 0x0000003f, 0x0000001f,
    0x0000000f, 0x00000007, 0x00000003, 0x00000001,
    0);
  return ((($v&$z[$c]) << $c)&0xffffffff) | (($v >> (32 - $c)) & $z[32-$c]);
}

function myXOR($v,$w)
{
  return $v ^ $w;
}

function PLUS($v,$w) {
  return ($v + $w) & 0xffffffff;
}

function PLUSONE($v)
{
  return PLUS($v,1);
}

function salsa20_wordtobyte(&$output, $input)
{
  for ($i = 0;$i < 16;++$i) $x[$i] = $input[$i];
  for ($i = 20;$i > 0;$i -= 2) {
    $x[ 4] = myXOR($x[ 4],ROTATE(PLUS($x[ 0],$x[12]), 7));
    $x[ 8] = myXOR($x[ 8],ROTATE(PLUS($x[ 4],$x[ 0]), 9));
    $x[12] = myXOR($x[12],ROTATE(PLUS($x[ 8],$x[ 4]),13));
    $x[ 0] = myXOR($x[ 0],ROTATE(PLUS($x[12],$x[ 8]),18));
    $x[ 9] = myXOR($x[ 9],ROTATE(PLUS($x[ 5],$x[ 1]), 7));
    $x[13] = myXOR($x[13],ROTATE(PLUS($x[ 9],$x[ 5]), 9));
    $x[ 1] = myXOR($x[ 1],ROTATE(PLUS($x[13],$x[ 9]),13));
    $x[ 5] = myXOR($x[ 5],ROTATE(PLUS($x[ 1],$x[13]),18));
    $x[14] = myXOR($x[14],ROTATE(PLUS($x[10],$x[ 6]), 7));
    $x[ 2] = myXOR($x[ 2],ROTATE(PLUS($x[14],$x[10]), 9));
    $x[ 6] = myXOR($x[ 6],ROTATE(PLUS($x[ 2],$x[14]),13));
    $x[10] = myXOR($x[10],ROTATE(PLUS($x[ 6],$x[ 2]),18));
    $x[ 3] = myXOR($x[ 3],ROTATE(PLUS($x[15],$x[11]), 7));
    $x[ 7] = myXOR($x[ 7],ROTATE(PLUS($x[ 3],$x[15]), 9));
    $x[11] = myXOR($x[11],ROTATE(PLUS($x[ 7],$x[ 3]),13));
    $x[15] = myXOR($x[15],ROTATE(PLUS($x[11],$x[ 7]),18));
    $x[ 1] = myXOR($x[ 1],ROTATE(PLUS($x[ 0],$x[ 3]), 7));
    $x[ 2] = myXOR($x[ 2],ROTATE(PLUS($x[ 1],$x[ 0]), 9));
    $x[ 3] = myXOR($x[ 3],ROTATE(PLUS($x[ 2],$x[ 1]),13));
    $x[ 0] = myXOR($x[ 0],ROTATE(PLUS($x[ 3],$x[ 2]),18));
    $x[ 6] = myXOR($x[ 6],ROTATE(PLUS($x[ 5],$x[ 4]), 7));
    $x[ 7] = myXOR($x[ 7],ROTATE(PLUS($x[ 6],$x[ 5]), 9));
    $x[ 4] = myXOR($x[ 4],ROTATE(PLUS($x[ 7],$x[ 6]),13));
    $x[ 5] = myXOR($x[ 5],ROTATE(PLUS($x[ 4],$x[ 7]),18));
    $x[11] = myXOR($x[11],ROTATE(PLUS($x[10],$x[ 9]), 7));
    $x[ 8] = myXOR($x[ 8],ROTATE(PLUS($x[11],$x[10]), 9));
    $x[ 9] = myXOR($x[ 9],ROTATE(PLUS($x[ 8],$x[11]),13));
    $x[10] = myXOR($x[10],ROTATE(PLUS($x[ 9],$x[ 8]),18));
    $x[12] = myXOR($x[12],ROTATE(PLUS($x[15],$x[14]), 7));
    $x[13] = myXOR($x[13],ROTATE(PLUS($x[12],$x[15]), 9));
    $x[14] = myXOR($x[14],ROTATE(PLUS($x[13],$x[12]),13));
    $x[15] = myXOR($x[15],ROTATE(PLUS($x[14],$x[13]),18));
  }
  for ($i = 0;$i < 16;++$i) $x[$i] = PLUS($x[$i],$input[$i]);
  for ($i = 0;$i < 16;++$i) {
    $output[$i*4] = $x[$i] & 0xff;
    $output[$i*4+1] = ($x[$i]>> 8) & 0xff;
    $output[$i*4+2] = ($x[$i]>>16) & 0xff;
    $output[$i*4+3] = ($x[$i]>>24) & 0xff;
  }
}

$sigma = "expand 32-byte k";
$tau = "expand 16-byte k";

function U8TO32_LITTLE($k, $i)
{
  return (ord($k[$i]) & 0xff) |
         ((ord($k[$i+1]) & 0xff)<<8) |
         ((ord($k[$i+2]) & 0xff)<<16) |
         ((ord($k[$i+3]) & 0xff)<<24);
}

function tou8($x)
{
  return chr($x & 0xff) .
         chr(($x>>8) & 0xff) .
         chr(($x>>16) & 0xff) .
         chr(($x>>24) & 0xff);
}

/* we force 256 bits key, iv length 64b */
function ECRYPT_keysetup($k)
{
  global $x_input;
  global $sigma;

  $constants = $sigma;

  $x_input[1] = U8TO32_LITTLE($k, 0);
  $x_input[2] = U8TO32_LITTLE($k, 4);
  $x_input[3] = U8TO32_LITTLE($k, 8);
  $x_input[4] = U8TO32_LITTLE($k, 12);
  $x_input[11] = U8TO32_LITTLE($k, 0 + 16);
  $x_input[12] = U8TO32_LITTLE($k, 4 + 16);
  $x_input[13] = U8TO32_LITTLE($k, 8 + 16);
  $x_input[14] = U8TO32_LITTLE($k, 12 + 16);
  $x_input[0] = U8TO32_LITTLE($constants, 0);
  $x_input[5] = U8TO32_LITTLE($constants, 4);
  $x_input[10] = U8TO32_LITTLE($constants, 8);
  $x_input[15] = U8TO32_LITTLE($constants, 12);
}

function ECRYPT_ivsetup($iv)
{
  global $x_input;
  $x_input[6] = U8TO32_LITTLE($iv, 0);
  $x_input[7] = U8TO32_LITTLE($iv, 4);
  $x_input[8] = U8TO32_LITTLE($iv, 8);
  $x_input[9] = U8TO32_LITTLE($iv, 12);
}

function salsa20_inc_iv()
{
  global $x_input;
  $x_input[8] = PLUSONE($x_input[8]);
  if (!$x_input[8]) {
    $x_input[9] = PLUSONE($x_input[9]);
    if (!$x_input[9]) {
      $x_input[6] = PLUSONE($x_input[6]);
      if (!$x_input[6]) {
        $x_input[7] = PLUSONE($x_input[7]);
      }
    }
  }
}

function salsa20_get_iv()
{
  global $x_input;
  return tou8($x_input[6]) .
         tou8($x_input[7]) .
         tou8($x_input[8]) .
         tou8($x_input[9]);
}

function ECRYPT_encrypt_bytes($m, &$c, $bytes)
{
  global $x_input;
  $c_index = 0;
  $m_index = 0;
  if (!$bytes) return;
  for (;;) {
    salsa20_wordtobyte($output,$x_input);
    salsa20_inc_iv();
    if ($bytes <= 64) {
      for ($i = 0;$i < $bytes;++$i)
        $c[$i+$c_index] = chr(ord($m[$i+$m_index]) ^ $output[$i]);
      return;
    }
    for ($i = 0;$i < 64;++$i)
      $c[$i+$c_index] = chr(ord($m[$i+$m_index]) ^ $output[$i]);
    $bytes -= 64;
    $c_index += 64;
    $m_index += 64;
  }
}

function ECRYPT_decrypt_bytes($c, &$m, $bytes)
{
  ECRYPT_encrypt_bytes($c, $m, $bytes);
}
?>
