<?php

/* ripped from Bernstein's stuff as can be seen.
 * Public domain stuff
 * Hardcorely inefficient.
 * All data are strings.
 * May fail to work on some hosts, php is weird with integers.
 */
/*
salsa20-ref.c version 20051118
D. J. Bernstein
Public domain.
*/

function PLUS($v,$w) {
  return ($v + $w) & 0xffffffff;
}

function PLUSONE($v)
{
  return PLUS($v,1);
}

$sigma = "expand 32-byte k";
$tau = "expand 16-byte k";

function U8TO32_LITTLE($k, $i)
{
  return (ord($k[$i]) & 0xff) |
         ((ord($k[$i+1]) & 0xff)<<8) |
         ((ord($k[$i+2]) & 0xff)<<16) |
         ((ord($k[$i+3]) & 0xff)<<24);
}

function tou8($x)
{
  return chr($x & 0xff) .
         chr(($x>>8) & 0xff) .
         chr(($x>>16) & 0xff) .
         chr(($x>>24) & 0xff);
}

/* we force 256 bits key, iv length 64b */
function ECRYPT_keysetup($k)
{
  global $x_input1;
  global $x_input2;
  global $x_input3;
  global $x_input4;
  global $x_input11;
  global $x_input12;
  global $x_input13;
  global $x_input14;
  global $x_input0;
  global $x_input5;
  global $x_input10;
  global $x_input15;
  global $sigma;

  $constants = $sigma;

  $x_input1 = U8TO32_LITTLE($k, 0);
  $x_input2 = U8TO32_LITTLE($k, 4);
  $x_input3 = U8TO32_LITTLE($k, 8);
  $x_input4 = U8TO32_LITTLE($k, 12);
  $x_input11 = U8TO32_LITTLE($k, 0 + 16);
  $x_input12 = U8TO32_LITTLE($k, 4 + 16);
  $x_input13 = U8TO32_LITTLE($k, 8 + 16);
  $x_input14 = U8TO32_LITTLE($k, 12 + 16);
  $x_input0 = U8TO32_LITTLE($constants, 0);
  $x_input5 = U8TO32_LITTLE($constants, 4);
  $x_input10 = U8TO32_LITTLE($constants, 8);
  $x_input15 = U8TO32_LITTLE($constants, 12);
}

function ECRYPT_ivsetup($iv)
{
  global $x_input6;
  global $x_input7;
  global $x_input8;
  global $x_input9;
  $x_input6 = U8TO32_LITTLE($iv, 0);
  $x_input7 = U8TO32_LITTLE($iv, 4);
  $x_input8 = U8TO32_LITTLE($iv, 8);
  $x_input9 = U8TO32_LITTLE($iv, 12);
}

function salsa20_get_iv()
{
  global $x_input6;
  global $x_input7;
  global $x_input8;
  global $x_input9;
  return tou8($x_input6) .
         tou8($x_input7) .
         tou8($x_input8) .
         tou8($x_input9);
}

function ECRYPT_encrypt_bytes($m, &$c, $bytes)
{
  global $x_input0; global $x_input1; global $x_input2; global $x_input3;
  global $x_input4; global $x_input5; global $x_input6; global $x_input7;
  global $x_input8; global $x_input9; global $x_input10; global $x_input11;
  global $x_input12; global $x_input13; global $x_input14; global $x_input15;
  $start = 0;
  if (!$bytes) return;
  for (;;) {

/* start of salsa20_wordtobyte($output,$x_input); */

  //for ($i = 0;$i < 16;++$i) $x[$i] = $x_input[$i];
  $x0 = $x_input0;
  $x1 = $x_input1;
  $x2 = $x_input2;
  $x3 = $x_input3;
  $x4 = $x_input4;
  $x5 = $x_input5;
  $x6 = $x_input6;
  $x7 = $x_input7;
  $x8 = $x_input8;
  $x9 = $x_input9;
  $x10 = $x_input10;
  $x11 = $x_input11;
  $x12 = $x_input12;
  $x13 = $x_input13;
  $x14 = $x_input14;
  $x15 = $x_input15;

  for ($i = 20;$i > 0;$i -= 2) {
    $t = $x0 + $x12;
    $x4 ^= 0xffffffff & (($t<<7)|($t>>25)&0x7f);
    $t = $x4+$x0;
    $x8 ^= 0xffffffff & (($t<<9)|($t>>23)&0x1ff);
    $t = $x8+$x4;
    $x12 ^= 0xffffffff & (($t<<13)|($t>>19)&0x1fff);
    $t = $x12+$x8;
    $x0 ^= 0xffffffff & (($t<<18)|($t>>14)&0x3ffff);
    $t = $x5+$x1;
    $x9 ^= 0xffffffff & (($t<<7)|($t>>25)&0x7f);
    $t = $x9+$x5;
    $x13 ^= 0xffffffff & (($t<<9)|($t>>23)&0x1ff);
    $t = $x13+$x9;

    $x1 ^= 0xffffffff & (($t<<13)|($t>>19)&0x1fff);
    $t = $x1+$x13;
    $x5 ^= 0xffffffff & (($t<<18)|($t>>14)&0x3ffff);
    $t = $x10+$x6;
    $x14 ^= 0xffffffff & (($t<<7)|($t>>25)&0x7f);
    $t = $x14+$x10;
    $x2 ^= 0xffffffff & (($t<<9)|($t>>23)&0x1ff);
    $t = $x2+$x14;
    $x6 ^= 0xffffffff & (($t<<13)|($t>>19)&0x1fff);
    $t = $x6+$x2;
    $x10 ^= 0xffffffff & (($t<<18)|($t>>14)&0x3ffff);
    $t = $x15+$x11;
    $x3 ^= 0xffffffff & (($t<<7)|($t>>25)&0x7f);
    $t = $x3+$x15;
    $x7 ^= 0xffffffff & (($t<<9)|($t>>23)&0x1ff);
    $t = $x7+$x3;

    $x11 ^= 0xffffffff & (($t<<13)|($t>>19)&0x1fff);
    $t = $x11+$x7;
    $x15 ^= 0xffffffff & (($t<<18)|($t>>14)&0x3ffff);
    $t = $x0+$x3;
    $x1 ^= 0xffffffff & (($t<<7)|($t>>25)&0x7f);
    $t = $x1+$x0;
    $x2 ^= 0xffffffff & (($t<<9)|($t>>23)&0x1ff);
    $t = $x2+$x1;
    $x3 ^= 0xffffffff & (($t<<13)|($t>>19)&0x1fff);
    $t = $x3+$x2;
    $x0 ^= 0xffffffff & (($t<<18)|($t>>14)&0x3ffff);
    $t = $x5+$x4;

    $x6 ^= 0xffffffff & (($t<<7)|($t>>25)&0x7f);
    $t = $x6+$x5;
    $x7 ^= 0xffffffff & (($t<<9)|($t>>23)&0x1ff);
    $t = $x7+$x6;
    $x4 ^= 0xffffffff & (($t<<13)|($t>>19)&0x1fff);
    $t = $x4+$x7;

    $x5 ^= 0xffffffff & (($t<<18)|($t>>14)&0x3ffff);
    $t = $x10+$x9;

    $x11 ^= 0xffffffff & (($t<<7)|($t>>25)&0x7f);
    $t = $x11+$x10;

    $x8 ^= 0xffffffff & (($t<<9)|($t>>23)&0x1ff);
    $t = $x8+$x11;

    $x9 ^= 0xffffffff & (($t<<13)|($t>>19)&0x1fff);
    $t = $x9+$x8;
    $x10 ^= 0xffffffff & (($t<<18)|($t>>14)&0x3ffff);
    $t = $x15+$x14;
    $x12 ^= 0xffffffff & (($t<<7)|($t>>25)&0x7f);
    $t = $x12+$x15;
    $x13 ^= 0xffffffff & (($t<<9)|($t>>23)&0x1ff);
    $t = $x13+$x12;
    $x14 ^= 0xffffffff & (($t<<13)|($t>>19)&0x1fff);
    $t = $x14+$x13;
    $x15 ^= 0xffffffff & (($t<<18)|($t>>14)&0x3ffff);
  }
  $x0 += $x_input0;
  $x1 += $x_input1;
  $x2 += $x_input2;
  $x3 += $x_input3;
  $x4 += $x_input4;
  $x5 += $x_input5;
  $x6 += $x_input6;
  $x7 += $x_input7;
  $x8 += $x_input8;
  $x9 += $x_input9;
  $x10 += $x_input10;
  $x11 += $x_input11;
  $x12 += $x_input12;
  $x13 += $x_input13;
  $x14 += $x_input14;
  $x15 += $x_input15;

  $output[0] = $x0 & 0xff;
  $output[1] = ($x0>> 8) & 0xff;
  $output[2] = ($x0>>16) & 0xff;
  $output[3] = ($x0>>24) & 0xff;
  $output[4] = $x1 & 0xff;
  $output[5] = ($x1>> 8) & 0xff;
  $output[6] = ($x1>>16) & 0xff;
  $output[7] = ($x1>>24) & 0xff;
  $output[8] = $x2 & 0xff;
  $output[9] = ($x2>> 8) & 0xff;
  $output[10] = ($x2>>16) & 0xff;
  $output[11] = ($x2>>24) & 0xff;
  $output[12] = $x3 & 0xff;
  $output[13] = ($x3>> 8) & 0xff;
  $output[14] = ($x3>>16) & 0xff;
  $output[15] = ($x3>>24) & 0xff;
  $output[16] = $x4 & 0xff;
  $output[17] = ($x4>> 8) & 0xff;
  $output[18] = ($x4>>16) & 0xff;
  $output[19] = ($x4>>24) & 0xff;
  $output[20] = $x5 & 0xff;
  $output[21] = ($x5>> 8) & 0xff;
  $output[22] = ($x5>>16) & 0xff;
  $output[23] = ($x5>>24) & 0xff;
  $output[24] = $x6 & 0xff;
  $output[25] = ($x6>> 8) & 0xff;
  $output[26] = ($x6>>16) & 0xff;
  $output[27] = ($x6>>24) & 0xff;
  $output[28] = $x7 & 0xff;
  $output[29] = ($x7>> 8) & 0xff;
  $output[30] = ($x7>>16) & 0xff;
  $output[31] = ($x7>>24) & 0xff;
  $output[32] = $x8 & 0xff;
  $output[33] = ($x8>> 8) & 0xff;
  $output[34] = ($x8>>16) & 0xff;
  $output[35] = ($x8>>24) & 0xff;
  $output[36] = $x9 & 0xff;
  $output[37] = ($x9>> 8) & 0xff;
  $output[38] = ($x9>>16) & 0xff;
  $output[39] = ($x9>>24) & 0xff;
  $output[40] = $x10 & 0xff;
  $output[41] = ($x10>> 8) & 0xff;
  $output[42] = ($x10>>16) & 0xff;
  $output[43] = ($x10>>24) & 0xff;
  $output[44] = $x11 & 0xff;
  $output[45] = ($x11>> 8) & 0xff;
  $output[46] = ($x11>>16) & 0xff;
  $output[47] = ($x11>>24) & 0xff;
  $output[48] = $x12 & 0xff;
  $output[49] = ($x12>> 8) & 0xff;
  $output[50] = ($x12>>16) & 0xff;
  $output[51] = ($x12>>24) & 0xff;
  $output[52] = $x13 & 0xff;
  $output[53] = ($x13>> 8) & 0xff;
  $output[54] = ($x13>>16) & 0xff;
  $output[55] = ($x13>>24) & 0xff;
  $output[56] = $x14 & 0xff;
  $output[57] = ($x14>> 8) & 0xff;
  $output[58] = ($x14>>16) & 0xff;
  $output[59] = ($x14>>24) & 0xff;
  $output[60] = $x15 & 0xff;
  $output[61] = ($x15>> 8) & 0xff;
  $output[62] = ($x15>>16) & 0xff;
  $output[63] = ($x15>>24) & 0xff;

/* end of salsa20_wordtobyte($output,$x_input); */

    $x_input8 = PLUSONE($x_input8);
    if (!$x_input8) {
      $x_input9 = PLUSONE($x_input9);
      if (!$x_input9) {
        $x_input6 = PLUSONE($x_input6);
        if (!$x_input6) {
          $x_input7 = PLUSONE($x_input7);
        }
      }
    }

    if ($bytes <= 64) {
      for ($i = 0;$i < $bytes;++$i)
        $c[$i+$start] = chr(ord($m[$i+$start]) ^ $output[$i]);
      return;
    }
    for ($i = 0;$i < 64;++$i)
      $c[$i+$start] = chr(ord($m[$i+$start]) ^ $output[$i]);
    $bytes -= 64;
    $start += 64;
  }
}

function ECRYPT_decrypt_bytes($c, &$m, $bytes)
{
  ECRYPT_encrypt_bytes($c, $m, $bytes);
}
?>
